const PaymentProcessor = require("./PaymentProcessor");

class Manual extends PaymentProcessor {

    #note;

    /**
     * 
     * Constructs a new manual Payment
     * No real payment is executed here but you can leave a note
     * describing the source/reason of this Payment
     * 
     * @param {String} note 
     */
    constructor(note = "") {
        super();

        this.#note = note;
    }

    async createOrder() {
        return Promise.resolve();
    }

    async captureOrder() {
        return Promise.resolve();
    }
    async refundOrder() {
        throw new Error("Manual Payments cannot be refunded");
    }

    /**
     * Turns class object into serializable data to store in redis db
     *
     * @returns {Object}
     */
    serialize() {
        return {
            processor_name: "Manual",
            note: this.#note
        };
    }

    /**
     * Turns class object into serializable data to store in redis db
     *
     * @returns {PaymentProcessor}
     */
    static DESERIALIZE(data) {
        return new Manual(data.note);
    }
}

module.exports = Manual;